pro animate_example

nx = 200 & nframes = 50
x = makepts(xlo = -10.0,xhi = 10.0,npts = nx)
center = makepts(xlo = -10.0,xhi = 10.0,npts = nframes)
fwhm = makepts(xlo = 1.0,xhi = 9.0,npts = nframes)
gauss_mat = fltarr(nx,nframes)
for i = 0,nframes-1 do $
   gauss_mat[*,i] = gaussian(x,center = center[i],fwhm = fwhm[i])

; First do it the "intuitive" way
winvis = 0
window,winvis,xsize = 400,ysize = 400
for i = 0,nframes-1 do begin
   plot,x,gauss_mat[*,i],thick = 2.0,yrange = [0.0,2.0],/ystyle
endfor

; Now do it using double-buffering
window,/free,/pixmap,xsize = 400,ysize = 400
winpix = !d.window

for i = 0,nframes-1 do begin
   wset,winpix
   plot,x,gauss_mat[*,i],thick = 2.0,yrange = [0.0,2.0],/ystyle
   wset,winvis
   device,copy = [0,0,!d.x_size,!d.y_size,0,0,winpix]
   wait,0.05
endfor
; Note that we must delete the memory associated with the pixmap
wdelete,winpix

end


pro test_pixmap
x = makepts(xlo = -5.0,xhi = 5.0,npts = 100)
gauss = gaussian(x)
window,0,xsize = 400,ysize = 400 ; create visible window
window,/free,/pixmap,xsize = 400,ysize = 400 ; create the pixmap
winpix = !d.window
wset,winpix ; first plot it in the pixmap
plot,x,gauss,thick = 2.0
wset,0 ; now copy it from the pixmap to the visible window
device,copy = [0,0,400,400,0,0,winpix]
wdelete,winpix ; free the memory associated with the pixmap
end