; **************************************** ;
pro image_gui_cleanup,tlb
widget_control,tlb,get_uvalue = pstate
wdelete,(*pstate).winpix1
wdelete,(*pstate).winpix2
wdelete,(*pstate).winpix3
heap_free,pstate
help,/heap,/brief
end
; **************************************** ;
pro image_gui_draw1,event
widget_control,event.top,get_uvalue = pstate
e = *(*pstate).eptr
q = *(*pstate).qptr
y = *(*pstate).zptr
if (*pstate).autoscale then begin
   (*pstate).xrange = [min(e),max(e)]
   (*pstate).yrange = [min(q),max(q)]
endif
de = e[1] - e[0]
dq = q[1] - q[0]
imgxrange = [min(e)-0.5*de,max(e)+0.5*de]
imgyrange = [min(q)-0.5*dq,max(q)+0.5*dq]
plotimage,bytscl(y),imgxrange = imgxrange,   $
         imgyrange = imgyrange,              $
         xrange = (*pstate).xrange,          $
         yrange = (*pstate).yrange,          $
         xtitle = (*pstate).xtitle,          $
         ytitle = (*pstate).ytitle
end
; **************************************** ;
pro image_gui_draw2,event
widget_control,event.top,get_uvalue = pstate
ycut = (*(*pstate).zptr)[*,(*pstate).qindex]
dycut = (*(*pstate).dzptr)[*,(*pstate).qindex]
dely = max(ycut)+max(dycut)
tvlct,r,g,b,/get
tvlct,(*(*pstate).color_ptr).r,  $
      (*(*pstate).color_ptr).g,  $
      (*(*pstate).color_ptr).b
plot,*(*pstate).eptr,ycut,psym = 4, $
   xrange = (*pstate).xrange,/xsty, $
   yrange = [0.0,1.1*dely],/ysty,   $
   xtitle = (*pstate).xtitle,       $
   ytitle = (*pstate).ztitle
errplot,*(*pstate).eptr,ycut-dycut,ycut+dycut,  $
   width = 0.0
; Now plot the vertical line
plots,[(*(*pstate).eptr)[(*pstate).eindex], $
       (*(*pstate).eptr)[(*pstate).eindex]],!y.crange,/data
tvlct,r,g,b
end
; **************************************** ;
pro image_gui_draw3,event
widget_control,event.top,get_uvalue = pstate
xcut = (*(*pstate).zptr)[(*pstate).eindex,*]
dxcut = (*(*pstate).dzptr)[(*pstate).eindex,*]
q = *(*pstate).qptr
delx = max(xcut)

tvlct,r,g,b,/get
tvlct,(*(*pstate).color_ptr).r,  $
      (*(*pstate).color_ptr).g,  $
      (*(*pstate).color_ptr).b
plot,xcut,*(*pstate).qptr,psym = 4, $
   yrange = (*pstate).yrange,/ysty, $
   xrange = reverse([0.0,1.1*delx]),/xsty, $
   xtitle = (*pstate).ztitle,       $
   ytitle = (*pstate).ytitle
for i = 0,n_elements(xcut)-1 do $
   plots,[xcut[i]-dxcut[i],xcut[i]+dxcut[i]], $
         [q[i],q[i]],/data
; Now plot the vertical line
plots,!x.crange,[(*(*pstate).qptr)[(*pstate).qindex], $
       (*(*pstate).qptr)[(*pstate).qindex]],/data
tvlct,r,g,b
end
; **************************************** ;
pro image_gui_refresh1,event
widget_control,event.top,get_uvalue = pstate
wset,(*pstate).winpix1
image_gui_draw1,event
wset,(*pstate).winvis1
device,copy = [0,0,!d.x_size,!d.y_size,   $
               0,0,(*pstate).winpix1]
end
; **************************************** ;
pro image_gui_refresh2,event
widget_control,event.top,get_uvalue = pstate
wset,(*pstate).winpix2
image_gui_draw2,event
wset,(*pstate).winvis2
device,copy = [0,0,!d.x_size,!d.y_size,   $
               0,0,(*pstate).winpix2]
end
; **************************************** ;
pro image_gui_refresh3,event
widget_control,event.top,get_uvalue = pstate
wset,(*pstate).winpix3
image_gui_draw3,event
wset,(*pstate).winvis3
device,copy = [0,0,!d.x_size,!d.y_size,   $
               0,0,(*pstate).winpix3]
end
; **************************************** ;
pro image_gui_change_colors,event
widget_control,event.top,get_uvalue = pstate
this_event = tag_names(event,/structure_name)
case this_event of
'WIDGET_BUTTON':  $
   xcolors,group_leader = event.top,   $
      notifyid = [event.id,event.top]
'XCOLORS_LOAD':   image_gui_refresh1,event
else:
endcase
end
; **************************************** ;
pro image_gui_win_events,event
widget_control,event.top,get_uvalue = pstate
if n_elements(*(*pstate).zptr) eq 0 then return
case event.type of
0: begin ; button press
      (*pstate).mouse = event.press
      if event.press eq 1 then begin
         ; Left mouse button
         (*pstate).xbox[0] = event.x
         (*pstate).ybox[0] = event.y
         image_gui_refresh1,event
         (*pstate).autoscale = 0B
      endif
   end
1: begin ; button release
      if (*pstate).mouse eq 4 then begin
         (*pstate).autoscale = 1B
         image_gui_refresh1,event
      endif
      if (*pstate).mouse eq 1 then begin
         xll = (*pstate).xbox[0] < (*pstate).xbox[1]
         yll = (*pstate).ybox[0] < (*pstate).ybox[1]
         w = abs((*pstate).xbox[1] - (*pstate).xbox[0])
         h = abs((*pstate).ybox[1] - (*pstate).ybox[0])
         xur = xll + w
         yur = yll + h
         ll = convert_coord(xll,yll,/device,/to_data)
         ur = convert_coord(xur,yur,/device,/to_data)
         (*pstate).xrange = [ll[0],ur[0]]
         (*pstate).yrange = [ll[1],ur[1]]
         image_gui_refresh1,event
      endif
      (*pstate).mouse = 0B
   end
2: begin ; motion events
      if (*pstate).mouse eq 1 then begin
         (*pstate).xbox[1] = event.x
         (*pstate).ybox[1] = event.y
         xc = [(*pstate).xbox[0],event.x,event.x,$
               (*pstate).xbox[0],$
               (*pstate).xbox[0]]
         yc = [(*pstate).ybox[0],(*pstate).ybox[0],$
               event.y,event.y,$
               (*pstate).ybox[0]]
         wset,(*pstate).winvis1
         device,copy = [0,0,!d.x_size,!d.y_size, $
            0,0,(*pstate).winpix1]
         plots,xc,yc,/device
      endif
      if (*pstate).mouse eq 0 then begin
         ; We haven't pressed a button.  The things that we
         ; need to do here are (1) display the current cursor
         ; coordinates in the widget labels and (2) generate
         ; the cuts.
         coords = convert_coord(event.x,event.y, $
            /device,/to_data)
         elo = min(*(*pstate).eptr,max = ehi)
         qlo = min(*(*pstate).qptr,max = qhi)
         condition = (coords[0] lt elo) or (coords[0] gt ehi) or $
                     (coords[1] lt qlo) or (coords[1] gt qhi)
         if condition then return
         e = *(*pstate).eptr
         q = *(*pstate).qptr
         eindex = (where(abs(e-coords[0]) eq min(abs(e-coords[0]))))[0]
         qindex = (where(abs(q-coords[1]) eq min(abs(q-coords[1]))))[0]

         xlabel = widget_info(event.top,find_by_uname = 'XLABEL')
         ylabel = widget_info(event.top,find_by_uname = 'YLABEL')
         zlabel = widget_info(event.top,find_by_uname = 'ZLABEL')
         widget_control,xlabel,set_value = 'x: '+ $
            strtrim(string(coords[0]),2)
         widget_control,ylabel,set_value = 'y: '+ $
            strtrim(string(coords[1]),2)
         widget_control,zlabel,set_value = 'z: '+  $
            strtrim(string((*(*pstate).zptr)[eindex,qindex]),2)
         (*pstate).qindex = qindex
         (*pstate).eindex = eindex
         image_gui_refresh3,event
         image_gui_refresh2,event
         image_gui_refresh1,event
         ; Plot the cross-hairs
         plots,!x.crange,replicate((*(*pstate).qptr)[qindex],2),/data
         plots,replicate((*(*pstate).eptr)[eindex],2),!y.crange,/data
      endif
   end
else:
endcase
end
; **************************************** ;
pro image_gui_load_data,event
widget_control,event.top,get_uvalue = pstate
filename = dialog_pickfile(dialog_parent = event.top, $
   filter = '*.sav',path = sourceroot())
if ~file_test(filename) then return
restore,filename = filename
*(*pstate).zptr = y
*(*pstate).dzptr = dy
*(*pstate).eptr = e
*(*pstate).qptr = q
image_gui_refresh3,event
image_gui_refresh2,event
image_gui_refresh1,event
end
; **************************************** ;
pro image_gui_show_surf,event
; Use FSC_SURFACE to display an interactive
; fully orientable 3D surface representation
; of the data.
widget_control,event.top,get_uvalue = pstate
if n_elements(*(*pstate).zptr) eq 0 then return
z = *(*pstate).zptr
x = *(*pstate).eptr
y = *(*pstate).qptr
nx = n_elements(x) & ny = n_elements(y)
; For aesthetic reasons, display the data as a square
; matrix.  Use congrid for the interpolation.
if nx ge ny then begin
   xi = x
   yi = makepts(xlo = min(y),xhi = max(y),npts = nx)
   zi = congrid(z,nx,nx,/cubic)
endif else begin
   xi = makepts(xlo = min(x),xhi = max(x),npts = ny)
   yi = y
   zi = congrid(z,ny,ny,/cubic)
endelse
fsc_surface, zi, xi, yi, group_leader = event.top, $
   /shaded,/elevation_shading,                  $
   xtitle = (*pstate).xtitle,                   $
   ytitle = (*pstate).ytitle,                   $
   colortable = 15
end
; **************************************** ;
pro image_gui_event,event
uname = widget_info(event.id,/uname)
case uname of
'LOAD':           image_gui_load_data,event
'QUIT':           widget_control,event.top,/destroy
'WIN':            image_gui_win_events,event
'CHANGE_COLORS':  image_gui_change_colors,event
'SHOW_SURF':      image_gui_show_surf,event
else:
endcase
end
; **************************************** ;
pro image_gui
if xregistered('image_gui') then return
; Widget creation module
; Initialize the color table to blue-white
device,decomposed = 0
loadct,1,/silent
; Load the colors into variables that we'll use
; to "color-protect" the cut data: i.e. we wish
; to maintain the white on black appearance of
; the cut plots but not affect the color table
; of the image plot.
tvlct,r,g,b,/get
color_ptr = ptr_new({r:r,g:g,b:b},/no_copy)
; Get the screen size to make the draw widgets
; appropriately sized.
device,get_screen_size = screen_size
; Define the sizes.  And just for fun we'll use the
; Golden Ratio to determine the size of the
; windows into which the cuts will be displayed.
golden_ratio = 0.5*(1.0+sqrt(5.))
xsize1 = (ysize1 = fix(0.35*screen_size[1]))
xsize2 = xsize1 & ysize2 = fix(ysize1/golden_ratio)
ysize3 = ysize1 & xsize3 = fix(xsize1/golden_ratio)
; Create the top-level base, make it a row-base, and
; specify that we want a menu bar
tlb = widget_base(/row,title = 'Data Display Application', $
   mbar = bar)
; Create the filemenu
filemenu = widget_button(bar,value = 'File',/menu)
void = widget_button(filemenu,value = 'Load data',uname = 'LOAD')
void = widget_button(filemenu,value = 'Change colors',uname = 'CHANGE_COLORS')
void = widget_button(filemenu,value = 'Surface representation',uname = 'SHOW_SURF')
void = widget_button(filemenu,value = 'Quit',uname = 'QUIT')
; Create the first column base which holds window 3
; and the label widget that will display the cursor
; coordinates in data units.
col1 = widget_base(tlb,/col)
win3 = widget_draw(col1,xsize = xsize3,ysize = ysize3)
xlabel = widget_label(col1,value = 'x: ',/dynamic_resize, $
   uname = 'XLABEL',/align_left)
ylabel = widget_label(col1,value = 'y: ',/dynamic_resize, $
   uname = 'YLABEL',/align_left)
zlabel = widget_label(col1,value = 'z: ',/dynamic_resize, $
   uname = 'ZLABEL',/align_left)
col2 = widget_base(tlb,/col)
win1 = widget_draw(col2,xsize = xsize1,ysize = ysize1,   $
   /motion_events,/button_events,uname = 'WIN')
win2 = widget_draw(col2,xsize = xsize2,ysize = ysize2)


; Let's center the top-level base on the screen
geom = widget_info(tlb,/geometry)
widget_control,tlb,  $
   xoff = (screen_size[0]/2)-(geom.scr_xsize/2),   $
   yoff = (screen_size[1]/2)-(geom.scr_ysize/2)
widget_control,tlb,/realize

; Get the window ids out and create the pixmaps
widget_control,win1,get_value = winvis1
widget_control,win2,get_value = winvis2
widget_control,win3,get_value = winvis3
window,/free,/pixmap,xsize = xsize1,ysize = ysize1
winpix1 = !d.window
window,/free,/pixmap,xsize = xsize2,ysize = ysize2
winpix2 = !d.window
window,/free,/pixmap,xsize = xsize3,ysize = ysize3
winpix3 = !d.window

; Initialize the pointers
zptr = ptr_new(/allocate_heap)
dzptr = ptr_new(/allocate_heap)
eptr = ptr_new(/allocate_heap)
qptr = ptr_new(/allocate_heap)

state = {   winvis1:winvis1,              $
            winvis2:winvis2,              $
            winvis3:winvis3,              $
            winpix1:winpix1,              $
            winpix2:winpix2,              $
            winpix3:winpix3,              $
            color_ptr:color_ptr,          $
            xtitle:'E (meV)',             $
            ytitle:'Q (!3!sA!r!u!9 %!3!n!E-1!N)',  $
            ztitle:'Intensity',           $

            mouse:0B,                     $
            autoscale:1B,                 $
            xbox:[0,0],                   $
            ybox:[0,0],                   $
            xrange:[0.,0.],               $
            yrange:[0.,0.],               $
            eindex:0,                     $
            qindex:0,                     $
            zptr:zptr,                    $
            dzptr:dzptr,                  $
            eptr:eptr,                    $
            qptr:qptr                     }

pstate = ptr_new(state,/no_copy)
widget_control,tlb,set_uvalue = pstate,/no_copy

xmanager,'image_gui',tlb,              $
   event_handler = 'image_gui_event',  $
   cleanup = 'image_gui_cleanup',      $
   /no_block

end