function lorentzian, x,                $
                     area = area,      $
                     center = center,  $
                     fwhm = fwhm,      $
                     plotit = plotit,  $
                     _Extra = extra

; Test for the presence of the input parameter x.
if (n_params() eq 0) or (n_elements(x) eq 0) then $
   x = makepts(xlo = -10.0,xhi = 10.0,npts = 100)
; Test for the presence of the keywords
if n_elements(area) eq 0 then area = 1.0
if n_elements(center) eq 0 then center = 0.0
if n_elements(fwhm) eq 0 then fwhm = 1.0

gam = 0.5*fwhm
yl = (area*gam/!pi)/((x-center)^2+gam^2)

; If the keyword PLOTIT has been set then plot the function
; in a new window.
if keyword_set(plotit) then begin
   window,/free,xsize = 300,ysize = 300
   plot,x,yl,psym = -4,xtitle = 'x',ytitle = 'y(x)', $
      title = 'Lorentzian Distribution',_Extra = extra
endif
return,yl
end
; ******* TEST_LORENTZ *******;
pro test_lorentz
device,decomposed = 0
loadct,0,/silent
white = 255 & black = 0
x = makepts(xlo = -5.0,xhi = 5.0,npts = 300)

plot,x,lorentzian(x),psym = 0,thick = 2.0,/nodata,color = black, $
   background = white,yrange = [-0.5,1.5],/ysty,   $
   title = '!3Lorentzian Distribution', xtitle = 'x',  $
   ytitle = 'y(x)'
oplot,x,lorentzian(x),psym = 0,thick = 2.0,color = black



end