pro plot_example

x = makepts(xlo = 0.0,xhi = 3.0*!pi,npts = 100)
phase = makepts(xlo = 0.0,xhi = 1.0*!pi,npts = 8)

; Legend parameters
xpos = 0.5 & ypos = 0.9
charsize = 1.5
; Plot the shifted sinusoids
plot,x,sin(x+phase[0]),psym = 1,       $
   xtitle = 'x',ytitle = 'y(x)',       $
   title = 'Shifted sinusoids',        $
   xrange = [min(x),max(x)],/xstyle,   $
   yrange = [-1.0,3.0],/ystyle
   legend_text = strtrim(string(1),2)+'!est!n data set'

; Add the legend text for this curve
   mylegend,   xpos,ypos,              $
               legend_text,            $
               psym = 1,               $
               charsize = charsize

for i = 1,n_elements(phase)-2 do begin
   oplot,x,sin(x+phase[i]),psym = i+1
   legend_text = strtrim(string(i+1),2)+'!eth!n data set'
;  Add the legend text for this curve
   mylegend,   xpos,ypos-0.05*i,       $
               legend_text,            $
               psym = i+1,             $
               charsize = charsize

endfor
save_as_jpeg,'plot_example_5'
end
