pro plotimage_example
; Set up the colors for this example
device,decomposed = 0
loadct,15,/silent
; Specify the ranges of the function
xlo = -10.0 & xhi = 10.0 & nx = 101
ylo = 0.0 & yhi = 5.0 & ny = 51
x = makepts(xlo = xlo,xhi = xhi,npts = nx)
y = makepts(xlo = ylo,xhi = yhi,npts = ny)
; Create the function to be displayed
z = sin(x#y)+0.1*randomn(s,nx,ny)
; Convert the function into a byte-scaled image
image = bytscl(z)
; PLOTIMAGE requires that we specify the range
; over which to plot the data.  In order to ensure
; a "bin-centered" plot for each pixel we subtract
; off half a bin from the lower bound and add
; half a bin to the upper bound.
dx = x[1] - x[0]
dy = y[1] - y[0]
imgxrange = [xlo-0.5*dx,xhi+0.5*dx]
imgyrange = [ylo-0.5*dy,yhi+0.5*dy]

; Open the window
window,0
erase,255B  ; erase the window with white
plotimage,image,imgxrange = imgxrange, $
         imgyrange = imgyrange,/noerase,color = 0

;filename = 'c:\idl_training\ornl\documentation\plotimage_example'
;write_jpeg,filename,image24,quality = 100,true = 1
;image = tvread(/jpeg,filename = filename)

end