pro speed_calc
num = 1600
; Calculate the difference array using loops
nx = num
; Create the x-vector
xlo = 0.0
xhi = 1.0
dx = (xhi-xlo)/(nx-1.0)
tstart = systime(/seconds) ; start the timer
x = fltarr(nx)
for i = 0,nx-1 do begin
   x[i] = xlo+dx*i
endfor
; Create the difference array
diff = fltarr(nx,nx)
for i = 0,nx-1 do begin
   for j = 0,nx-1 do begin
     diff[i,j] = x[i] - x[j]
   endfor
endfor
t_loop = systime(/seconds)-tstart   ; calculate elapsed time
print,'Time elapsed (loop method):',t_loop

; Ok, now do it the optimized IDL way
tstart = systime(/seconds) ; start the timer
x = xlo+dx*findgen(nx)
ux = 1+bytarr(nx)
diff_array = ux#x-x#ux
t_no_loops = systime(/seconds)-tstart  ; calculate elapsed time
print,'Time elapsed (no loops):',t_no_loops
print,'Speed factor improvement: ',t_loop/t_no_loops
end
