; ***************************** ;
pro widget_ex_2_event,event
; This is the main event handler.  We
; parse the event by the user-name of
; the widget that generated it.
uname = widget_info(event.id,/uname)
case uname of
'QUIT':  widget_control,event.top,/destroy
'INPUT_TEXT':  $
   begin
      ; We first need to get the widget identifier
      ; for the output text field
      out_label_id = widget_info(event.top, $
         find_by_uname = 'OUTPUT_TEXT')
      ; Get the current text value from the input
      ; text widget
      widget_control,event.id,get_value = val
      ; Set the current text value from the input
      ; text widget in the output text widget
      widget_control,out_label_id,set_value = val
   end
else:
endcase
end
; ***************************** ;
pro widget_ex_2
; This is the second widget example
;
; Create the top-level base
tlb = widget_base(/col,title = 'Second Widget')
; Create a label
input_label_id = widget_label(tlb,value = 'Input')
; Create an editable input text widget.
; Moreover set the ALL_EVENTS keyword so that
; any change in the text field generates an
; event.
input_text_id = widget_text(tlb,value = '',/editable, $
   uname = 'INPUT_TEXT',xsize = 50,/all_events)
; Create the output label
out_label_id = widget_label(tlb,value = 'Output')
; Create an uneditable output text widget
output_text_id = widget_text(tlb,value = '', $
   uname = 'OUTPUT_TEXT',xsize = 50)

; Create a QUIT button on the top-level base
quit = widget_button(tlb,value = 'QUIT',uname = 'QUIT')

; Render the widgets on the screen
widget_control,tlb,/realize
; Start up the XMANAGER which manages the
; widget events
xmanager,'widget_ex_2',tlb,   $
   event_handler = 'widget_ex_2_event',/no_block

end